' set response horizon
!hrz = 20

smpl 1950:1 1980:1
var var_p.ls 1 4 l_gg l_tt l_yy @ c

' get residuals to bootstrap
var_p.makeresid(n=gres) res_l_gg res_l_tt res_l_yy  

' make model to generate bootstrap data
model model_bt
model_bt.merge var_p
'model_bt.append dy_i=dy_i(-1)*(1+0.25*i)/(1+l_yy-l_yy(-1)+infl_q) +0.25*(exp(l_gg)-exp(l_tt))/(exp(l_yy))

' assign add factors for bootstrap residuals
model_bt.addassign(i)  l_gg l_tt l_yy 

'set random number generator
rndseed(type=mt) 1234567

'declare storage matrices
!reps = 500
for !i=1 to 6
	matrix(!hrz,!reps) brsp_lvl{!i}
	matrix(!hrz,!reps) brsp_acc{!i}
next

'temporary working vector
vector vtmp
'count number of cases that converged
scalar cnt = 0

'bootstrap loop
for !i=1 to !reps
'bootstrap residuals
smpl @all if res_l_gg<>na
gres.resample l_gg_a l_tt_a l_yy_a 

'generate bootstrap data
model_bt.solve

'estimate XVAR  with bootstrap data
smpl 1950:1 1980:1
var var_2.ls 1 4 l_gg_0 l_tt_0 l_yy_0 @  c 

'structuralization
var_2.cleartext(svar)
var_2.append(svar) @e1= c(1)*@u1
var_2.append(svar) @e2= 1.75*@e3 + c(2)*@u1+c(3)*@u2
var_2.append(svar) @e3= c(4)*@e1+c(5)*@e2+c(6)*@u3
'var_2.append(svar) @e4= c(7)*@e1+c(8)*@e2+c(9)*@e3+c(10)*@u4
'var_2.append(svar) @e5= c(11)*@e1+c(12)*@e2+c(13)*@e3+c(14)*@e4+c(15)*@u5

' estimate structural factorization
var_2.svar(rtype=text,conv=1e-5)

matrix MAT_A=var_2.@svaramat
matrix MAT_B=var_2.@svarbmat
matrix mat_c=@inverse(mat_a)*mat_b

model model_blc
model_blc.merge var_2
'model_blc.append dy_i_0=dy_i_0(-1)*(1+0.25*i_0)/(1+l_yy_0-l_yy_0(-1)+infl_q_0) +0.25*(exp(l_gg_0)-exp(l_tt_0))/(exp(l_yy_0))

model_blc.append assign @all  _fbl
model model_alc
model_alc.append assign @all  _fal

model_alc.append l_gg_0 = var_2.c(1,1)*l_gg_0(-1) + var_2.c(1,2)*l_gg_0(-2) + var_2.c(1,3)*l_gg_0(-3) + var_2.c(1,4)*l_gg_0(-4) + var_2.c(1,5)*l_tt_0(-1) + var_2.c(1,6)*l_tt_0(-2) + var_2.c(1,7)*l_tt_0(-3) + var_2.c(1,8)*l_tt_0(-4) + var_2.c(1,9)*l_yy_0(-1) + var_2.c(1,10)*l_yy_0(-2) + var_2.c(1,11)*l_yy_0(-3) + var_2.c(1,12)*l_yy_0(-4) + var_2.c(1,13) +mat_c(1,1)*shock1+mat_c(1,2)*shock2

model_alc.append l_tt_0 = var_2.c(2,1)*l_gg_0(-1) + var_2.c(2,2)*l_gg_0(-2) + var_2.c(2,3)*l_gg_0(-3) + var_2.c(2,4)*l_gg_0(-4) + var_2.c(2,5)*l_tt_0(-1) + var_2.c(2,6)*l_tt_0(-2) + var_2.c(2,7)*l_tt_0(-3) + var_2.c(2,8)*l_tt_0(-4) + var_2.c(2,9)*l_yy_0(-1) + var_2.c(2,10)*l_yy_0(-2) + var_2.c(2,11)*l_yy_0(-3) + var_2.c(2,12)*l_yy_0(-4) + var_2.c(2,13) + mat_c(2,1)*shock1+mat_c(2,2)*shock2

model_alc.append l_yy_0 = var_2.c(3,1)*l_gg_0(-1) + var_2.c(3,2)*l_gg_0(-2) + var_2.c(3,3)*l_gg_0(-3) + var_2.c(3,4)*l_gg_0(-4) + var_2.c(3,5)*l_tt_0(-1) + var_2.c(3,6)*l_tt_0(-2) + var_2.c(3,7)*l_tt_0(-3) + var_2.c(3,8)*l_tt_0(-4) + var_2.c(3,9)*l_yy_0(-1) + var_2.c(3,10)*l_yy_0(-2) + var_2.c(3,11)*l_yy_0(-3) + var_2.c(3,12)*l_yy_0(-4) + var_2.c(3,13) +mat_c(3,1)*shock1+mat_c(3,2)*shock2

smpl @all
series shock1=0
series shock2=0
smpl 1980:1+1 1980:1+1
shock1=.01
shock2=0

smpl 1980:1+1 1980:1+!hrz
model_blc.solve
model_alc.solve
genr re_pc_lgg_s_lgg=l_gg_0_fal- l_gg_0_fbl
genr re_pc_ltt_s_lgg=l_tt_0_fal- l_tt_0_fbl
genr re_pc_lyy_s_lgg=l_yy_0_fal- l_yy_0_fbl

smpl 1980:1+1 1980:1+1
genr acc_re_pc_lgg_s_lgg=re_pc_lgg_s_lgg
genr acc_re_pc_ltt_s_lgg=re_pc_ltt_s_lgg
genr acc_re_pc_lyy_s_lgg=re_pc_lyy_s_lgg

smpl 1980:1+2 1980:1+!hrz
series acc_re_pc_lgg_s_lgg=acc_re_pc_lgg_s_lgg(-1)+re_pc_lgg_s_lgg
series acc_re_pc_ltt_s_lgg=acc_re_pc_ltt_s_lgg(-1)+re_pc_ltt_s_lgg
series acc_re_pc_lyy_s_lgg=acc_re_pc_lyy_s_lgg(-1)+re_pc_lyy_s_lgg

smpl 1980:1+1 1980:1+1
shock1=0
shock2=.01

smpl 1980:1+1 1980:1+!hrz
model_blc.solve
model_alc.solve
genr re_pc_lgg_s_ltt=l_gg_0_fal- l_gg_0_fbl
genr re_pc_ltt_s_ltt=l_tt_0_fal- l_tt_0_fbl
genr re_pc_lyy_s_ltt=l_yy_0_fal- l_yy_0_fbl

smpl 1980:1+1 1980:1+1
genr acc_re_pc_lgg_s_ltt=re_pc_lgg_s_ltt
genr acc_re_pc_ltt_s_ltt=re_pc_ltt_s_ltt
genr acc_re_pc_lyy_s_ltt=re_pc_lyy_s_ltt


smpl 1980:1+2 1980:1+!hrz
series acc_re_pc_lgg_s_ltt=acc_re_pc_lgg_s_ltt(-1)+re_pc_lgg_s_ltt
series acc_re_pc_ltt_s_ltt=acc_re_pc_ltt_s_ltt(-1)+re_pc_ltt_s_ltt
series acc_re_pc_lyy_s_ltt=acc_re_pc_lyy_s_ltt(-1)+re_pc_lyy_s_ltt

smpl 1980:1+1 1980:1+!hrz
'get level and accumulated bootstrap responses
group imp_varpc
imp_varpc.add  re_pc_lgg_s_lgg re_pc_ltt_s_lgg re_pc_lyy_s_lgg re_pc_lgg_s_ltt re_pc_ltt_s_ltt re_pc_lyy_s_ltt 
stom(imp_varpc,tmp_lvl)
delete imp_varpc
'group acc_imp_varpc
'acc_imp_varpc.add  acc_re_pc_lgg_s_lgg acc_re_pc_ltt_s_lgg acc_re_pc_lyy_s_lgg acc_re_pc_infl_q_s_lgg acc_re_pc_i_s_lgg acc_re_pc_dy_i_s_lgg acc_re_pc_lgg_s_ltt acc_re_pc_ltt_s_ltt acc_re_pc_lyy_s_ltt acc_re_pc_infl_q_s_ltt acc_re_pc_i_s_ltt acc_re_pc_dy_i_s_ltt
'stom(acc_imp_varpc,tmp_acc)
'delete acc_imp_varpc
'and store in appropriate position
		for !j=1 to 6
			vtmp = @columnextract(tmp_lvl,!j)
			colplace(brsp_lvl{!j}, vtmp, !i)
'			vtmp = @columnextract(tmp_acc,!j)
'			colplace(brsp_acc{!j}, vtmp, !i)
next
delete tmp_lvl 'tmp_acc
cnt=cnt+1
next
'find bootstrap percentiles for each horizon
matrix(!hrz,6) rsp_lvl_bps_upp_1
matrix(!hrz,6) rsp_lvl_bps_med_1
matrix(!hrz,6) rsp_lvl_bps_low_1
'matrix(!hrz,@columns(rsp_lvl_bpsim)) rsp_acc_bp_upp
'matrix(!hrz,@columns(rsp_lvl_bpsim)) rsp_acc_bp_med
'matrix(!hrz,@columns(rsp_lvl_bpsim)) rsp_acc_bp_low

rowvector rtmp
for !i=1 to !hrz
	for !j=1 to 6
		rtmp = @rowextract(brsp_lvl{!j},!i)
		rsp_lvl_bps_upp_1(!i,!j) = @quantile(rtmp,0.833)
		rsp_lvl_bps_med_1(!i,!j) = @quantile(rtmp,0.5)
		rsp_lvl_bps_low_1(!i,!j) = @quantile(rtmp,0.167)
'		rtmp = @rowextract(brsp_acc{!j},!i)
'		rsp_acc_bp_upp(!i,!j) = @quantile(rtmp,0.833)
'		rsp_acc_bp_med(!i,!j) = @quantile(rtmp,0.833)
'		rsp_acc_bp_low(!i,!j) = @quantile(rtmp,0.167)
	next
next

smpl 1950:1 1980:1
scalar factor=0.01*(@mean(yy)/@mean(tt))/rsp_lvl_bps_med(1,5)
smpl 1980:1+1 1980:1+!hrz
matrix rsp_lvl_bps_med_1_tr= rsp_lvl_bps_med_1*factor
matrix rsp_lvl_bps_low_1_tr=rsp_lvl_bps_low_1*factor
matrix rsp_lvl_bps_upp_1_tr= rsp_lvl_bps_upp_1*factor


delete res_l_gg res_l_tt res_l_yy  'res_infl_q res_i
delete re_*  acc_* brsp_*
delete dy_i_0* i_0* infl_q_0* l_gg_0* l_tt_0* l_yy_0* gres
delete l_gg_a l_tt_a l_yy_a  vtmp rtmp shock1 shock2
delete rsp_acc_bp*



	matrix(20,9) FIG1_BP_SMALL_1
	
	vector prova
	prova = @columnextract(rsp_lvl_bps_LOW_1_TR,6)	
	colplace(FIG1_BP_SMALL_1,prova,1)
	prova = @columnextract(rsp_lvl_bps_MED_1_TR,6)
	colplace(FIG1_BP_SMALL_1,prova,2)
	prova= @columnextract(rsp_lvl_bps_upp_1_TR,6)
	colplace(FIG1_BP_SMALL_1,prova,3)
	prova = @columnextract(rsp_lvl_bp_LOW_1_TR,9)	
	colplace(FIG1_BP_SMALL_1,prova,4)
	prova = @columnextract(rsp_lvl_bp_MED_1_TR,9)
	colplace(FIG1_BP_SMALL_1,prova,5)
	prova= @columnextract(rsp_lvl_bp_upp_1_TR,9)
	colplace(FIG1_BP_SMALL_1,prova,6)
	prova = @columnextract(RSP_ACC_ROM_LOW_1,1)	
	colplace(FIG1_BP_SMALL_1,prova,7)
	prova = @columnextract(RSP_ACC_ROM_MED_1,1)
	colplace(FIG1_BP_SMALL_1,prova,8)
	prova= @columnextract(RSP_ACC_ROM_UPP_1,1)
	colplace(FIG1_BP_SMALL_1,prova,9)

' make graph
%type="COMPARISON_1"
%name = "fig1_"
delete {%name}{%type}*
	freeze({%name}{%type}) FIG1_BP_SMALL_1.line
	{%name}{%type}.axis(l) grid zeroline range(-0.06,.01)
	{%name}{%type}.axis(b) grid 
	{%name}{%type}.option linepat	' need to set linepat
	{%name}{%type}.draw(line,left,rgb(180,180,180)) 0
	{%name}{%type}.elem(1) lcolor(green) lpat(dash2) lwidth(0.5)
	{%name}{%type}.elem(2) lcolor(green) lpat(solid) lwidth(1.5)
	{%name}{%type}.elem(3) lcolor(green) lpat(dash2) lwidth(0.5)
	{%name}{%type}.elem(4) lcolor(red) lpat(dash2) lwidth(0.5)
	{%name}{%type}.elem(5) lcolor(red) lpat(solid) lwidth(1.5)
	{%name}{%type}.elem(6) lcolor(red) lpat(dash2) lwidth(0.5)
	{%name}{%type}.elem(7) lcolor(blue) lpat(dash2) lwidth(0.5)
	{%name}{%type}.elem(8) lcolor(blue) lpat(solid) lwidth(1.5)
	{%name}{%type}.elem(9) lcolor(blue) lpat(dash2) lwidth(0.5)
	{%name}{%type}.name(1) 
	{%name}{%type}.name(2) SMALL
	{%name}{%type}.name(3) 
	{%name}{%type}.name(4) 
	{%name}{%type}.name(5) LARGE
	{%name}{%type}.name(6) 
	{%name}{%type}.name(7) 
	{%name}{%type}.name(8) R&R
	{%name}{%type}.name(9) 
	{%name}{%type}.legend(B)

