' JP 19/10/10

' Set response horizon
!horz = 20

delete var1*
delete var2*
smpl 1947:1 2007:1
var var1.ls 1 4 L_YY L_GG L_TT  @ C TT_ROM

var1.makeresid(n=gres) res_YY res_GG res_TT

' make model to generate bootstrap data
model model_bt
model_bt.merge var1

' assign add factors for bootstrap residuals
model_bt.addassign(i) L_YY L_GG L_TT  

'set random number generator
rndseed(type=mt) 1234567


'declare storage matrices
!reps = 1000
for !i=1 to 3
	matrix(!horz,!reps) brsp_lvl{!i}
	matrix(!horz,!reps) brsp_acc{!i}
next

'temporary working vector
vector vtmp
'count number of cases that converged
scalar cnt = 0


'bootstrap loop
for !i=1 to !reps
smpl @all
'bootstrap residuals
smpl @all if res_YY<>na
gres.resample L_YY_a   L_GG_a   L_TT_a  

'generate bootstrap data
model_bt.solve
delete var2*
smpl 1947:1 2007:1
var var2.ls 1 4 L_YY_0 L_GG_0 L_TT_0 @ C TT_ROM

model model_blc
model_blc.merge var2
model_blc.append assign @all  _fbl

model model_alc
model_alc.merge var2
model_alc.append assign @all  _fal

smpl 2007:1+1 2007:1+!horz
TT_ROM=0
model_blc.solve

smpl 2007:1+1 2007:1+1
TT_ROM= 0.01
smpl 2007:1+1 2007:1+!HORZ
model_alc.solve
TT_ROM=0

genr re_L_YY_s = L_YY_0_fal - L_YY_0_fbl
genr re_L_GG_s = L_GG_0_fal - L_GG_0_fbl
genr re_L_TT_s = L_TT_0_fal - L_TT_0_fbl

smpl 2007:1+1 2007:1+1

genr acc_re_L_YY_s = re_L_YY_s
genr acc_re_L_GG_s = re_L_GG_s
genr acc_re_L_TT_s = re_L_TT_s


smpl 2007:1+2 2007:1+!HORZ

series acc_re_L_YY_s = acc_re_L_YY_s(-1) + re_L_YY_s
series acc_re_L_GG_s = acc_re_L_GG_s(-1) + re_L_GG_s
series acc_re_L_TT_s = acc_re_L_TT_s(-1) + re_L_TT_s

smpl 2007:1+1 2007:1+!HORZ

group lvl_var_small
lvl_var_small.add  re_L_YY_s re_L_GG_s re_L_TT_s
stom(lvl_var_small,tmp_lvl)
delete lvl_var_small

group acc_var_small
acc_var_small.add  acc_re_L_YY_s acc_re_L_GG_s acc_re_L_TT_s
stom(acc_var_small,tmp_acc)
delete acc_var_small

'and store in appropriate position
		for !j=1 to 3
			vtmp = @columnextract(tmp_lvl,!j)
			colplace(brsp_lvl{!j}, vtmp, !i)
			vtmp = @columnextract(tmp_acc,!j)
			colplace(brsp_acc{!j}, vtmp, !i)
next
delete tmp_lvl tmp_acc
cnt=cnt+1
next


'find bootstrap percentiles for each horizon
matrix(!horz,3) rsp_fgs_upp
matrix(!horz,3) rsp_fgs_low
matrix(!horz,3) rsp_fgs_med

rowvector rtmp
for !i=1 to !horz
	for !j=1 to 3
		rtmp = @rowextract(brsp_lvl{!j},!i)
		rsp_fgs_upp(!i,!j) = @quantile(rtmp,0.84)
		rsp_fgs_med(!i,!j) = @quantile(rtmp,0.50)
		rsp_fgs_low(!i,!j) = @quantile(rtmp,0.16)
	next
next

delete re_*
delete res_*
delete acc_*
delete brsp_*
delete *_fal
delete *_fbl
delete *_0
delete *_a
delete gres
delete  vtmp rtmp
delete model_*

'*********************************
'      PLOTTING GRAPHS
'*********************************
	matrix(20,6) PLOT_SMALL
	
	vector prova
	prova = @columnextract(RSP_LVL_VAR_LOW ,3)	
	colplace(PLOT_SMALL,prova,1)
	prova = @columnextract(RSP_LVL_VAR_MED,3)
	colplace(PLOT_SMALL,prova,2)
	prova= @columnextract(RSP_LVL_VAR_UPP,3)
	colplace(PLOT_SMALL,prova,3)
	prova = @columnextract(rsp_fgs_low,1)	
	colplace(PLOT_SMALL,prova,4)
	prova = @columnextract(rsp_fgs_med,1)
	colplace(PLOT_SMALL,prova,5)
	prova= @columnextract(rsp_fgs_upp,1)
	colplace(PLOT_SMALL,prova,6)

' make graph
%type=""
%name = "figure5b"
delete {%name}{%type}*
	freeze({%name}{%type}) PLOT_SMALL.line
	{%name}{%type}.axis(l) grid zeroline range(-0.06,.01)
	{%name}{%type}.axis(b) grid 
	{%name}{%type}.option linepat	' need to set linepat
	{%name}{%type}.draw(line,left,rgb(180,180,180)) 0
	{%name}{%type}.elem(1) lcolor(blue) lpat(dash2) lwidth(0.5)
	{%name}{%type}.elem(2) lcolor(blue) lpat(solid) lwidth(1.5)
	{%name}{%type}.elem(3) lcolor(blue) lpat(dash2) lwidth(0.5)
	{%name}{%type}.elem(4) lcolor(red) lpat(dash2) lwidth(0.5)
	{%name}{%type}.elem(5) lcolor(red) lpat(solid) lwidth(1.5)
	{%name}{%type}.elem(6) lcolor(red) lpat(dash2) lwidth(0.5)
	{%name}{%type}.name(1) 
	{%name}{%type}.name(2) LARGE
	{%name}{%type}.name(3) 
	{%name}{%type}.name(4) 
	{%name}{%type}.name(5) SMALL
	{%name}{%type}.name(6) 
	{%name}{%type}.legend(B)

