delete imp_varp*
delete acc_imp_varp*
delete rsp_acc_bp*
delete rsp_acc_bp_sim*
delete rsp_lvl_bp*
delete rsp_lvl_bp_se*
delete rsp_lvl_bpsim*

!hrz=20
smpl 1950:1 2007:1
var var_p.ls 1 4  l_gg l_tt l_yy  infl_q i 
var_p.makeresids res_l_gg res_l_tt res_lyy res_infl_q res_i 
var_p.cleartext(svar)
var_p.append(svar) @e1=-0.5*@e4 +c(1)*@u1
var_p.append(svar) @e2=1.85*@e3+1.25*@e4+c(2)*@u1+c(3)*@u2
var_p.append(svar) @e3=c(4)*@e1+c(5)*@e2+c(6)*@u3
var_p.append(svar) @e4=c(7)*@e1+c(8)*@e2+c(9)*@e3+c(10)*@u4
var_p.append(svar) @e5=c(11)*@e1+c(12)*@e2+c(13)*@e3+c(14)*@e4+c(15)*@u5

' estimate structural factorization
var_p.svar(rtype=text,conv=1e-5)
var_p.impulse(!hrz,m,imp=struct,se=a,matbys=rsp_lvl_bp) l_gg l_tt l_yy  infl_q i @ l_gg l_tt
var_p.impulse(!hrz,m,imp=struct,a,matbys=rsp_acc_bp) l_gg l_tt l_yy  infl_q i @ l_gg l_tt

matrix MAT_A=var_p.@svaramat
matrix MAT_B=var_p.@svarbmat
matrix mat_c=@inverse(mat_a)*mat_b
matrix mat_d=@inverse(mat_b)*mat_a
genr res_l_gg_st=mat_d(1,1)*res_l_gg +mat_d(1,2)*res_l_tt +mat_d(1,3)*res_lyy +mat_d(1,4)*res_infl_q + mat_d(1,5)*res_i
genr res_l_tt_st=mat_d(2,1)*res_l_gg +mat_d(2,2)*res_l_tt +mat_d(2,3)*res_lyy +mat_d(2,4)*res_infl_q + mat_d(2,5)*res_i
smpl @all
series shock1=0
series shock2=0
smpl 2007:1+1 2007:1+1
shock1=1
shock2=0

model model_bl
model_bl.merge var_p
model_bl.append dy_i=dy_i(-1)*(1+0.25*i)/(1+l_yy-l_yy(-1)+infl_q) +0.25*(exp(l_gg)-exp(l_tt))/(exp(l_yy))
model_bl.append assign @all  _fbl
model model_al
model_al.append assign @all  _fal

model_al.append L_GG = var_p.c(1,1)*L_GG(-1) + var_p.c(1,2)*L_GG(-2) + var_p.c(1,3)*L_GG(-3) + var_p.c(1,4)*L_GG(-4) + var_p.c(1,5)*L_TT(-1) + var_p.c(1,6)*L_TT(-2) + var_p.c(1,7)*L_TT(-3) + var_p.c(1,8)*L_TT(-4) + var_p.c(1,9)*L_YY(-1) + var_p.c(1,10)*L_YY(-2) + var_p.c(1,11)*L_YY(-3) + var_p.c(1,12)*L_YY(-4) + var_p.c(1,13)*INFL_Q(-1) + var_p.c(1,14)*INFL_Q(-2) + var_p.c(1,15)*INFL_Q(-3) + var_p.c(1,16)*INFL_Q(-4) + var_p.c(1,17)*I(-1) + var_p.c(1,18)*I(-2) + var_p.c(1,19)*I(-3) + var_p.c(1,20)*I(-4) + var_p.c(1,21)+mat_c(1,1)*shock1+mat_c(1,2)*shock2

model_al.append L_TT = var_p.c(2,1)*L_GG(-1) + var_p.c(2,2)*L_GG(-2) + var_p.c(2,3)*L_GG(-3) + var_p.c(2,4)*L_GG(-4) + var_p.c(2,5)*L_TT(-1) + var_p.c(2,6)*L_TT(-2) + var_p.c(2,7)*L_TT(-3) + var_p.c(2,8)*L_TT(-4) + var_p.c(2,9)*L_YY(-1) + var_p.c(2,10)*L_YY(-2) + var_p.c(2,11)*L_YY(-3) + var_p.c(2,12)*L_YY(-4) + var_p.c(2,13)*INFL_Q(-1) + var_p.c(2,14)*INFL_Q(-2) + var_p.c(2,15)*INFL_Q(-3) + var_p.c(2,16)*INFL_Q(-4) + var_p.c(2,17)*I(-1) + var_p.c(2,18)*I(-2) + var_p.c(2,19)*I(-3) + var_p.c(2,20)*I(-4) + var_p.c(2,21)+mat_c(2,1)*shock1+mat_c(2,2)*shock2

model_al.append L_YY = var_p.c(3,1)*L_GG(-1) + var_p.c(3,2)*L_GG(-2) + var_p.c(3,3)*L_GG(-3) + var_p.c(3,4)*L_GG(-4) + var_p.c(3,5)*L_TT(-1) + var_p.c(3,6)*L_TT(-2) + var_p.c(3,7)*L_TT(-3) + var_p.c(3,8)*L_TT(-4) + var_p.c(3,9)*L_YY(-1) + var_p.c(3,10)*L_YY(-2) + var_p.c(3,11)*L_YY(-3) + var_p.c(3,12)*L_YY(-4) + var_p.c(3,13)*INFL_Q(-1) + var_p.c(3,14)*INFL_Q(-2) + var_p.c(3,15)*INFL_Q(-3) + var_p.c(3,16)*INFL_Q(-4) + var_p.c(3,17)*I(-1) + var_p.c(3,18)*I(-2) + var_p.c(3,19)*I(-3) + var_p.c(3,20)*I(-4) + var_p.c(3,21)+mat_c(3,1)*shock1+mat_c(3,2)*shock2

model_al.append INFL_Q = var_p.c(4,1)*L_GG(-1) + var_p.c(4,2)*L_GG(-2) + var_p.c(4,3)*L_GG(-3) + var_p.c(4,4)*L_GG(-4) + var_p.c(4,5)*L_TT(-1) + var_p.c(4,6)*L_TT(-2) + var_p.c(4,7)*L_TT(-3) + var_p.c(4,8)*L_TT(-4) + var_p.c(4,9)*L_YY(-1) + var_p.c(4,10)*L_YY(-2) + var_p.c(4,11)*L_YY(-3) + var_p.c(4,12)*L_YY(-4) + var_p.c(4,13)*INFL_Q(-1) + var_p.c(4,14)*INFL_Q(-2) + var_p.c(4,15)*INFL_Q(-3) + var_p.c(4,16)*INFL_Q(-4) + var_p.c(4,17)*I(-1) + var_p.c(4,18)*I(-2) + var_p.c(4,19)*I(-3) + var_p.c(4,20)*I(-4) + var_p.c(4,21)+mat_c(4,1)*shock1+mat_c(4,2)*shock2

model_al.append I = var_p.c(5,1)*L_GG(-1) + var_p.c(5,2)*L_GG(-2) + var_p.c(5,3)*L_GG(-3) + var_p.c(5,4)*L_GG(-4) + var_p.c(5,5)*L_TT(-1) + var_p.c(5,6)*L_TT(-2) + var_p.c(5,7)*L_TT(-3) + var_p.c(5,8)*L_TT(-4) + var_p.c(5,9)*L_YY(-1) + var_p.c(5,10)*L_YY(-2) + var_p.c(5,11)*L_YY(-3) + var_p.c(5,12)*L_YY(-4) + var_p.c(5,13)*INFL_Q(-1) + var_p.c(5,14)*INFL_Q(-2) + var_p.c(5,15)*INFL_Q(-3) + var_p.c(5,16)*INFL_Q(-4) + var_p.c(5,17)*I(-1) + var_p.c(5,18)*I(-2) + var_p.c(5,19)*I(-3) + var_p.c(5,20)*I(-4) + var_p.c(5,21)+mat_c(5,1)*shock1+mat_c(5,2)*shock2

model_al.append dy_i=dy_i(-1)*(1+0.25*i)/(1+l_yy-l_yy(-1)+infl_q) +0.25*(exp(l_gg)-exp(l_tt))/(exp(l_yy))

smpl @all
series shock1=0
series shock2=0
smpl 2007:1+1 2007:1+1
shock1=1
shock2=0
smpl 2007:1+1 2007:1+!hrz
model_bl.solve
model_al.solve
genr re_p_lgg_s_lgg=l_gg_fal- l_gg_fbl
genr re_p_ltt_s_lgg=l_tt_fal- l_tt_fbl
genr re_p_lyy_s_lgg=l_yy_fal- l_yy_fbl
genr re_p_infl_q_s_lgg=infl_q_fal- infl_q_fbl
genr re_p_i_s_lgg=i_fal- i_fbl
genr re_p_dy_i_s_lgg=dy_i_fal- dy_i_fbl


smpl 2007:1+1 2007:1+1
genr acc_re_p_lgg_s_lgg=re_p_lgg_s_lgg
genr acc_re_p_ltt_s_lgg=re_p_ltt_s_lgg
genr acc_re_p_lyy_s_lgg=re_p_lyy_s_lgg
genr acc_re_p_infl_q_s_lgg=re_p_infl_q_s_lgg
genr acc_re_p_i_s_lgg=re_p_i_s_lgg
genr acc_re_p_dy_i_s_lgg=re_p_dy_i_s_lgg


smpl 2007:1+2 2007:1+!hrz
series acc_re_p_lgg_s_lgg=acc_re_p_lgg_s_lgg(-1)+re_p_lgg_s_lgg
series acc_re_p_ltt_s_lgg=acc_re_p_ltt_s_lgg(-1)+re_p_ltt_s_lgg
series acc_re_p_lyy_s_lgg=acc_re_p_lyy_s_lgg(-1)+re_p_lyy_s_lgg
series acc_re_p_infl_q_s_lgg=acc_re_p_infl_q_s_lgg(-1)+re_p_infl_q_s_lgg
series acc_re_p_i_s_lgg=acc_re_p_i_s_lgg(-1)+re_p_i_s_lgg
series acc_re_p_dy_i_s_lgg=acc_re_p_dy_i_s_lgg(-1)+re_p_dy_i_s_lgg



smpl 2007:1+1 2007:1+1
shock1=0
shock2=1

smpl 2007:1+1 2007:1+!hrz
model_bl.solve
model_al.solve
genr re_p_lgg_s_ltt=l_gg_fal- l_gg_fbl
genr re_p_ltt_s_ltt=l_tt_fal- l_tt_fbl
genr re_p_lyy_s_ltt=l_yy_fal- l_yy_fbl
genr re_p_infl_q_s_ltt=infl_q_fal- infl_q_fbl
genr re_p_i_s_ltt=i_fal- i_fbl
genr re_p_dy_i_s_ltt=dy_i_fal- dy_i_fbl


smpl 2007:1+1 2007:1+1
genr acc_re_p_lgg_s_ltt=re_p_lgg_s_ltt
genr acc_re_p_ltt_s_ltt=re_p_ltt_s_ltt
genr acc_re_p_lyy_s_ltt=re_p_lyy_s_ltt
genr acc_re_p_infl_q_s_ltt=re_p_infl_q_s_ltt
genr acc_re_p_i_s_ltt=re_p_i_s_ltt
genr acc_re_p_dy_i_s_ltt=re_p_dy_i_s_ltt


smpl 2007:1+2 2007:1+!hrz
series acc_re_p_lgg_s_ltt=acc_re_p_lgg_s_ltt(-1)+re_p_lgg_s_ltt
series acc_re_p_ltt_s_ltt=acc_re_p_ltt_s_ltt(-1)+re_p_ltt_s_ltt
series acc_re_p_lyy_s_ltt=acc_re_p_lyy_s_ltt(-1)+re_p_lyy_s_ltt
series acc_re_p_infl_q_s_ltt=acc_re_p_infl_q_s_ltt(-1)+re_p_infl_q_s_ltt
series acc_re_p_i_s_ltt=acc_re_p_i_s_ltt(-1)+re_p_i_s_ltt
series acc_re_p_dy_i_s_ltt=acc_re_p_dy_i_s_ltt(-1)+re_p_dy_i_s_ltt


smpl 2007:1+1 2007:1+!hrz
group imp_varp
imp_varp.add  re_p_lgg_s_lgg re_p_ltt_s_lgg re_p_lyy_s_lgg re_p_infl_q_s_lgg re_p_i_s_lgg re_p_dy_i_s_lgg re_p_lgg_s_ltt re_p_ltt_s_ltt re_p_lyy_s_ltt re_p_infl_q_s_ltt re_p_i_s_ltt re_p_dy_i_s_ltt
stom(imp_varp,rsp_lvl_bpsim)

group acc_imp_varp
acc_imp_varp.add  acc_re_p_lgg_s_lgg acc_re_p_ltt_s_lgg acc_re_p_lyy_s_lgg acc_re_p_infl_q_s_lgg acc_re_p_i_s_lgg acc_re_p_dy_i_s_lgg acc_re_p_lgg_s_ltt acc_re_p_ltt_s_ltt acc_re_p_lyy_s_ltt acc_re_p_infl_q_s_ltt acc_re_p_i_s_ltt acc_re_p_dy_i_s_ltt
stom(acc_imp_varp,rsp_acc_bp_sim)

delete re_*
delete acc_*
delete model_al
delete model_bl

