' bootstrap VAR impulse responses with romers variable, to be run after sim_imp_romer
' written by C.A.Favero 4/3/2007

matrix (20,6) rsp_lvl_rom_var
' set response horizon
!horz= 20


smpl 1950:1 1980:4
var_rom.ls
' 1 4 l_gg l_tt l_yy infl_q i @  c tt_rom

' get residuals to bootstrap
var_rom.makeresid(n=gres) res_l_gg res_l_tt res_l_yy  res_infl_q res_i

' make model to generate bootstrap data
model model_bt
model_bt.merge var_rom
model_bt.append dy_i=dy_i(-1)*(1+0.25*i)/(1+l_yy-l_yy(-1)+infl_q) +0.25*(exp(l_gg)-exp(l_tt))/(exp(l_yy))

' assign add factors for bootstrap residuals
model_bt.addassign(i)  l_gg l_tt l_yy infl_q i

'set random number generator
rndseed(type=mt) 1234567

'declare storage matrices
!reps = 500
for !i=1 to 6
	matrix(!horz,!reps) brsp_lvl{!i}
	matrix(!horz,!reps) brsp_acc{!i}
next

'temporary working vector
vector vtmp
'count number of cases that converged
scalar cnt = 0

'bootstrap loop
for !i=1 to !reps
'bootstrap residuals
smpl @all if res_l_gg<>na
gres.resample l_gg_a l_tt_a l_yy_a infl_q_a i_a

'generate bootstrap data
model_bt.solve

'estimate XVAR  with bootstrap data
smpl 1950:2 1980:4
var_2.ls 
'1 4 l_gg_0 l_tt_0 l_yy_0 infl_q_0 i_0 @  c tt_rom

model model_blc
model_blc.merge var_2
model_blc.append dy_i_0=dy_i_0(-1)*(1+0.25*i_0)/(1+l_yy_0-l_yy_0(-1)+infl_q_0) +0.25*(exp(l_gg_0)-exp(l_tt_0))/(exp(l_yy_0))
model_blc.append assign @all  _fbl

model model_alc
model_alc.merge var_2
model_alc.append dy_i_0=dy_i_0(-1)*(1+0.25*i_0)/(1+l_yy_0-l_yy_0(-1)+infl_q_0) +0.25*(exp(l_gg_0)-exp(l_tt_0))/(exp(l_yy_0))
model_alc.append assign @all  _fal

smpl 1980:4+1 1980:4+!horz
tt_rom=0
model_blc.solve

smpl 1980:4+1 1980:4+1
tt_rom=0.01
smpl 1980:4+1 1980:4+!horz
model_alc.solve
smpl 1980:4+1 1980:4+1
tt_rom=0
smpl 1980:4+1 1980:4+!horz

genr re_lgg_s_rom=l_gg_0_fal- l_gg_0_fbl
genr re_ltt_s_rom=l_tt_0_fal- l_tt_0_fbl
genr re_lyy_s_rom=l_yy_0_fal- l_yy_0_fbl
genr re_infl_q_s_rom=infl_q_0_fal- infl_q_0_fbl
genr re_i_s_rom=i_0_fal- i_0_fbl
genr re_dy_i_s_rom=dy_i_0_fal- dy_i_0_fbl

smpl 1980:4+1 1980:4+1

genr acc_re_lgg_s_rom=re_lgg_s_rom
genr acc_re_ltt_s_rom=re_ltt_s_rom
genr acc_re_lyy_s_rom=re_lyy_s_rom
genr acc_re_infl_q_s_rom=re_infl_q_s_rom
genr acc_re_i_s_rom=re_i_s_rom
genr acc_re_dy_i_s_rom=re_dy_i_s_rom
smpl 1980:4+2 1980:4+!horz
series acc_re_lgg_s_rom=acc_re_lgg_s_rom(-1)+re_lgg_s_rom
series acc_re_ltt_s_rom=acc_re_ltt_s_rom(-1)+re_ltt_s_rom
series acc_re_lyy_s_rom=acc_re_lyy_s_rom(-1)+re_lyy_s_rom
series acc_re_infl_q_s_rom=acc_re_infl_q_s_rom(-1)+re_infl_q_s_rom
series acc_re_i_s_rom=acc_re_i_s_rom(-1)+re_i_s_rom
series acc_re_dy_i_s_rom=acc_re_dy_i_s_rom(-1)+re_dy_i_s_rom

smpl 1980:4+1 1980:4+!horz
'get level and accumulated bootstrap responses
group imp_var_rom
imp_var_rom.add  re_lgg_s_rom re_ltt_s_rom re_lyy_s_rom re_infl_q_s_rom re_i_s_rom re_dy_i_s_rom 
stom(imp_var_rom,tmp_lvl)
delete imp_var_rom
group acc_imp_var_rom
acc_imp_var_rom.add  acc_re_lgg_s_rom acc_re_ltt_s_rom acc_re_lyy_s_rom acc_re_infl_q_s_rom acc_re_i_s_rom acc_re_dy_i_s_rom
stom(acc_imp_var_rom,tmp_acc)
delete acc_imp_*
'and store in appropriate position
		for !j=1 to @columns(rsp_lvl_rom_var)
			vtmp = @columnextract(tmp_lvl,!j)
			colplace(brsp_lvl{!j}, vtmp, !i)
			vtmp = @columnextract(tmp_acc,!j)
			colplace(brsp_acc{!j}, vtmp, !i)
next
delete tmp_lvl tmp_acc
cnt=cnt+1
next


'find bootstrap percentiles for each horizon
matrix(!horz,@columns(rsp_lvl_rom_var)) rsp_lvl_var_upp_1
matrix(!horz,@columns(rsp_lvl_rom_var)) rsp_lvl_var_med_1
matrix(!horz,@columns(rsp_lvl_rom_var)) rsp_lvl_var_low_1

rowvector rtmp
for !i=1 to !horz
	for !j=1 to @columns(rsp_lvl_rom_var)
		rtmp = @rowextract(brsp_lvl{!j},!i)
		rsp_lvl_var_upp_1(!i,!j) = @quantile(rtmp,0.833)
		rsp_lvl_var_med_1(!i,!j) = @quantile(rtmp,0.50)	
		rsp_lvl_var_low_1(!i,!j) = @quantile(rtmp,0.167)	
next
next

vector v
matrix(20,3) bootstrap_var_1
	v = @columnextract(rsp_lvl_var_low_1,3)
	colplace(bootstrap_var_1,v,1)
	v = @columnextract(rsp_lvl_var_med_1,3)
	colplace(bootstrap_var_1,v,2)
	v = @columnextract(rsp_lvl_var_upp_1,3)
	colplace(bootstrap_var_1,v,3)
delete v


' Restore exogenous fiscal shock
smpl 1980:4+1 1980:4+!horz
tt_rom=rec_exo/gdp



delete re_*
delete res_*
delete acc_*
delete brsp_*
delete dy_i_0*
delete i_0*
delete infl_q_0*
delete l_gg_0*
delete l_tt_0* 
delete l_yy_0*
delete gres
delete i_a infl_q_a l_gg_a l_tt_a l_yy_a  vtmp rtmp
delete model_*

