' ***************************************************************
' bivariate VAR in ROMER
'***************************************************************

smpl 1960:1 2006:2
var var_romer_12.ls 1 12  tt_rom l_yy
'freeze(var_romer2_sall) var_romer2
var_romer_12.makeresids res_tt_rom_12  res_gr_qgdp_12

var var_romer_8.ls 1 8  tt_rom l_yy
'freeze(var_romer2_sall) var_romer2
var_romer_8.makeresids res_tt_rom_8  res_gr_qgdp_8

var var_romer_4.ls 1 4  tt_rom l_yy
'freeze(var_romer2_sall) var_romer2
var_romer_4.makeresids res_tt_rom_4  res_gr_qgdp_4

equation eq_filter.ls TT_ROM = C(1) + C(2)*TT_ROM(-1) + C(3)*TT_ROM(-2) + C(4)*TT_ROM(-3) + C(5)*TT_ROM(-4)  +C(7)*L_GG(-1) + C(8)*L_GG(-2) + C(9)*L_GG(-3) + C(10)*L_GG(-4) + C(11)*L_TT(-1) + C(12)*L_TT(-2) + C(13)*L_TT(-3) + C(14)*L_TT(-4) + C(15)*L_YY(-1) + C(16)*L_YY(-2) + C(17)*L_YY(-3) + C(18)*L_YY(-4) + C(19)*INFL_Q(-1) + C(20)*INFL_Q(-2) + C(21)*INFL_Q(-3) + C(22)*INFL_Q(-4) + C(23)*I(-1) + C(24)*I(-2) + C(25)*I(-3) + C(26)*I(-4) 

eq_filter.makeresids res_tt_rom_var

delete tmp_graph*
graph tmp_graph1.line  tt_rom 
tmp_graph1.option linepat	' need to set linepat
	tmp_graph1.elem(1) lcolor(black) lpat(solid) lwidth(2)
		tmp_graph1.draw(line,left,rgb(180,180,180)) 0
		tmp_graph1.name(1)  R&R shocks
tmp_graph1.axis(left)  grid zeroline 

graph tmp_graph2.line   res_tt_rom_4
tmp_graph2.option linepat	' need to set linepat
	tmp_graph2.elem(1) lcolor(blue) lpat(solid) lwidth(2)
		tmp_graph1.draw(line,left,rgb(180,180,180)) 0
		tmp_graph2.name(1) R&R in Fiscal VAR  4 lags
	tmp_graph2.axis(left)  grid zeroline 

     graph tmp_graph3.line   res_tt_rom_8
tmp_graph3.option linepat	' need to set linepat
	tmp_graph3.elem(1) lcolor(red) lpat(solid) lwidth(2)
		tmp_graph3.draw(line,left,rgb(180,180,180)) 0
		tmp_graph3.name(1) R&R in Fiscal VAR  8 lags
tmp_graph3.axis(left)  grid zeroline 
 

graph tmp_graph4.line   res_tt_rom_12
tmp_graph4.option linepat	' need to set linepat
	tmp_graph4.elem(1) lcolor(green) lpat(solid) lwidth(2)
		tmp_graph4.draw(line,left,rgb(180,180,180)) 0
	tmp_graph4.axis(left)  grid zeroline 
tmp_graph4.name(1) R&R in Fiscal VAR  12 lags

graph tmp_graph5.line   res_tt_rom_var
tmp_graph5.option linepat	' need to set linepat
	tmp_graph5.elem(1) lcolor(black) lpat(dash1) lwidth(2)
tmp_graph5.draw(line,left,rgb(180,180,180)) 0
	tmp_graph5.axis(left)  grid zeroline 
tmp_graph5.name(1) R&R shocks filtered with VAR variables
delete graph_ttrom*
graph graph_ttrom.merge tmp_graph1 tmp_graph2 tmp_graph3  tmp_graph4 
graph graph_ttrom1.merge tmp_graph1 tmp_graph5
delete tmp_graph*




stop

' **************************************************************
'Imposing short-run restrictions on VAR, using Perotti's elasticities 
'**************************************************************
var_p.append(svar) @e1=-0.5*@e4 +c(1)*@u1
var_p.append(svar) @e2=1.75*@e3+1.09*@e4+c(2)*@u1+c(3)*@u2
var_p.append(svar) @e3=c(4)*@e1+c(5)*@e2+c(6)*@u3
var_p.append(svar) @e4=c(7)*@e1+c(8)*@e2+c(9)*@e3+c(10)*@u4
var_p.append(svar) @e5=c(11)*@e1+c(12)*@e2+c(13)*@e3+c(14)*@e4+c(15)*@u5

' estimate structural factorization
freeze(svar_p_sall) var_p.svar(rtype=text,maxiter=1000,conv=1e-5)
var_p.impulse(20,m,imp=struct,se=a) l_gg l_tt l_yy  infl_q i @ l_gg l_tt
matrix MAT_A=var_p.@svaramat
matrix MAT_B=var_p.@svarbmat
matrix mat_d=@inverse(mat_b)*mat_a
genr res_l_gg_st=mat_d(1,1)*res_l_gg +mat_d(1,2)*res_l_tt +mat_d(1,3)*res_lyy +mat_d(1,4)*res_infl_q + mat_d(1,5)*res_i
genr res_l_tt_st=mat_d(2,1)*res_l_gg +mat_d(2,2)*res_l_tt +mat_d(2,3)*res_lyy +mat_d(2,4)*res_infl_q + mat_d(2,5)*res_i

' ***************************************************************
' VAR model Impulse Response Functions and Forecast Errors' Variance Decompositions
' ***************************************************************

' calculate impulse response functions, make graphs 
freeze(var_pIRFsall) var_p.impulse(20,m,imp=struct,se=a)  l_gg l_tt l_yy  infl_q i @ l_gg l_tt

freeze(var_pIRFtable_sall) var_p.impulse(20,t,a,imp=struct,se=a)  l_gg l_tt l_yy  infl_q i @ l_gg l_tt

' calculate forecast error decomposition, make table
'freeze(var_pdecomptable) var_p.decomp(10,t,imp=struct,se=a) l_yy infl_q i @ l_tt l_gg
'freeze(var_pdecomp) var_p.decomp(10,m,imp=struct,se=a) l_yy infl_q i @ l_tt l_gg

var var_pc.ls 1 4 l_gg l_tt l_yy infl_q i @  c (dy_i(-1)-0.35)
freeze(var_pc_coeff_sall) var_pc
var_pc.makeresids resc_l_gg resc_l_tt resc_lyy resc_infl_q resc_i 


' **************************************************************
'Imposing short-run restrictions on VAR, using Perotti's elasticities 
'**************************************************************
var_pc.append(svar) @e1=-0.5*@e4 +c(1)*@u1
var_pc.append(svar) @e2=1.75*@e3+1.09*@e4+c(2)*@u1+c(3)*@u2
var_pc.append(svar) @e3=c(4)*@e1+c(5)*@e2+c(6)*@u3
var_pc.append(svar) @e4=c(7)*@e1+c(8)*@e2+c(9)*@e3+c(10)*@u4
var_pc.append(svar) @e5=c(11)*@e1+c(12)*@e2+c(13)*@e3+c(14)*@e4+c(15)*@u5

' estimate structural factorization
freeze(svar_pc_sall) var_pc.svar(rtype=text,conv=1e-5)
'var_pc.impulse(20,m,imp=struct,se=a) l_gg l_tt l_yy  infl_q i @ l_gg l_tt
matrix MAT_Ac=var_pc.@svaramat
matrix MAT_Bc=var_pc.@svarbmat
matrix mat_dc=@inverse(mat_bc)*mat_ac
genr resc_l_gg_st=mat_dc(1,1)*resc_l_gg +mat_dc(1,2)*resc_l_tt +mat_dc(1,3)*resc_lyy +mat_dc(1,4)*resc_infl_q + mat_dc(1,5)*resc_i
genr resc_l_tt_st=mat_dc(2,1)*resc_l_gg +mat_dc(2,2)*resc_l_tt +mat_dc(2,3)*resc_lyy +mat_dc(2,4)*resc_infl_q + mat_dc(2,5)*resc_i

