' JP 21.05.2010

'delete bootstrap
' set response horizon
!horz = 26

smpl 1950:1 2007:1
var_u.ls

' get residuals to bootstrap
var_u.makeresid(n=gres) res_l_gg  res_l_yy  res_infl_q res_i res_l_tt

' make model to generate bootstrap data
model model_bt
model_bt.merge var_u

' assign add factors for bootstrap residuals
model_bt.addassign(i)  l_gg  l_yy infl_q i l_tt

'set random number generator
rndseed(type=mt) 1234567

'declare storage matrices
!reps = 500
for !i=1 to 5
	matrix(!horz,!reps) brsp_lvl{!i}
next

'temporary working vector
vector vtmp
'count number of cases that converged
scalar cnt = 0

'bootstrap loop
for !i=1 to !reps
'bootstrap residuals
smpl @all if res_l_gg<>na
gres.resample l_gg_a l_yy_a infl_q_a i_a  l_tt_a

'generate bootstrap data
model_bt.solve

'estimate XVAR  with bootstrap data
smpl 1950:2 2007:1
var_u_2.ls 

model model_blc
model_blc.merge var_u_2
model_blc.append assign @all  _fbl

model model_alc
model_alc.merge var_u_2
model_alc.append assign @all  _fal


smpl 2007:1+1 2007:1+!horz
SUT= 0
SATT= 0
SAT1 = 0
SAT2 = 0
SAT3 = 0
SAT4 = 0
SAT5 = 0
SAT6= 0
model_blc.solve

for !j=1 to 6
smpl 2007:1+(7-!j) 2007:1+(7-!j)
SAT{!j}=0.01
next
smpl 2007:1+7 2007:1+7
SATT=0.01
smpl 2007:1+1 2007:1+!horz
model_alc.solve


smpl 2007:1+1 2007:1+!horz
SUT= 0
SATT= 0
SAT1 = 0
SAT2 = 0
SAT3 = 0
SAT4 = 0
SAT5 = 0
SAT6= 0



genr re_lgg_s_rom=l_gg_0_fal- l_gg_0_fbl
genr re_ltt_s_rom=l_tt_0_fal- l_tt_0_fbl
genr re_lyy_s_rom=l_yy_0_fal- l_yy_0_fbl
genr re_infl_q_s_rom=infl_q_0_fal- infl_q_0_fbl
genr re_i_s_rom=i_0_fal- i_0_fbl

smpl 2007:1+1 2007:1+1

genr acc_re_lgg_s_rom=re_lgg_s_rom
genr acc_re_ltt_s_rom=re_ltt_s_rom
genr acc_re_lyy_s_rom=re_lyy_s_rom
genr acc_re_infl_q_s_rom=re_infl_q_s_rom
genr acc_re_i_s_rom=re_i_s_rom


smpl 2007:1+1 2007:1+!horz
'get level bootstrap responses
group imp_var_rom
imp_var_rom.add  re_lgg_s_rom re_lyy_s_rom re_infl_q_s_rom re_i_s_rom re_ltt_s_rom 
stom(imp_var_rom,tmp_lvl)
delete imp_var_rom

'and store in appropriate position
		for !j=1 to 5
			vtmp = @columnextract(tmp_lvl,!j)
			colplace(brsp_lvl{!j}, vtmp, !i)
		next

delete tmp_lvl
cnt=cnt+1
next


'find bootstrap percentiles for each horizon
matrix(!horz,5) rsp_lvl_var_mra_upp
matrix(!horz,5) rsp_lvl_var_mra_low
matrix(!horz,5) rsp_lvl_var_mra_med

rowvector rtmp
for !i=1 to !horz
	for !j=1 to 5
		rtmp = @rowextract(brsp_lvl{!j},!i)
		rsp_lvl_var_mra_upp(!i,!j) = @quantile(rtmp,0.833)
		rsp_lvl_var_mra_med(!i,!j) = @quantile(rtmp,0.50)
		rsp_lvl_var_mra_low(!i,!j) = @quantile(rtmp,0.167)
	next
next


delete re_*
delete res_*
delete acc_*
delete brsp_*
delete i_0*
delete infl_q_0*
delete l_gg_0*
delete l_tt_0* 
delete l_yy_0*
delete gres
delete i_a infl_q_a l_gg_a l_tt_a l_yy_a  vtmp rtmp
delete model_*

