' bootstrap structural Romer and Romer impulse response function, to be run after "transform" and "sim_rom"
' written by C.A.Favero 26/3/2007



' set response horizon
!hrz = 20
smpl @all
series tt_rom_def1=tt_rom_def
smpl 1950:1 1980:4
equation eq_romer_def_1.ls gr_qgdp c tt_rom_def1 tt_rom_def1(-1 to -12)
' get residuals to bootstrap
eq_romer_def_1.makeresids res_rom


' make model to generate bootstrap data
model model_bt
model_bt.merge eq_romer_def_1

' assign add factors for bootstrap residuals
model_bt.addassign(i)  gr_qgdp

'set random number generator
rndseed(type=mt) 1234567

'declare storage matrices
!reps = 500
for !i=1 to 1
	matrix(!hrz,!reps) brsp_lvl{!i}
	matrix(!hrz,!reps) brsp_acc{!i}
next

'temporary working vector
vector vtmp
'count number of cases that converged
scalar cnt = 0

'bootstrap loop
for !i=1 to !reps
'bootstrap residuals
smpl @all if res_rom<>na
res_rom.resample gr_qgdp_a

'generate bootstrap data
model_bt.solve

'estimate romer eq  with bootstrap data
smpl 1950:1 1980:4
equation eq_2.ls gr_qgdp_0  c tt_rom_def1 tt_rom_def1(-1 to -12)

model model_blc
model_blc.merge eq_2
model_blc.append assign @all  _fbl
model model_alc
model_alc.merge eq_2
model_alc.append assign @all  _fal

smpl 1980:4+1 1980:4+!hrz
tt_rom_def1 =0
model_blc.solve

smpl 1980:4+1 1980:4+1
tt_rom_def1 =0.01
smpl 1980:4+1 1980:4+!hrz
model_alc.solve

genr re_y_rom=gr_qgdp_0_fal-gr_qgdp_0_fbl

smpl 1980:4+1 1980:4+1
genr acc_re_y_rom=re_y_rom

smpl 1980:4+2 1980:4+!hrz
series acc_re_y_rom=acc_re_y_rom(-1)+re_y_rom


smpl 1980:4+1 1980:4+!hrz
'get level and accumulated bootstrap responses
group imp_rom
imp_rom.add  re_y_rom
stom(imp_rom,tmp_lvl)
delete imp_rom
group acc_imp_rom
acc_imp_rom.add  acc_re_y_rom
stom(acc_imp_rom,tmp_acc)
delete acc_imp_rom
'and store in appropriate position
		for !j=1 to @columns(rsp_lvl_rom)
			vtmp = @columnextract(tmp_lvl,!j)
			colplace(brsp_lvl{!j}, vtmp, !i)
			vtmp = @columnextract(tmp_acc,!j)
			colplace(brsp_acc{!j}, vtmp, !i)
next
delete tmp_lvl tmp_acc
cnt=cnt+1
next
'find bootstrap percentiles for each horizon
matrix(!hrz,@columns(rsp_lvl_rom)) rsp_lvl_rom_def_upp_1
matrix(!hrz,@columns(rsp_lvl_rom)) rsp_lvl_rom_def_low_1
matrix(!hrz,@columns(rsp_lvl_rom)) rsp_lvl_rom_def_med_1
matrix(!hrz,@columns(rsp_lvl_rom)) rsp_acc_rom_def_upp_1
matrix(!hrz,@columns(rsp_lvl_rom)) rsp_acc_rom_def_low_1
matrix(!hrz,@columns(rsp_lvl_rom)) rsp_acc_rom_def_med_1


rowvector rtmp
for !i=1 to !hrz
	for !j=1 to @columns(rsp_lvl_rom)
		rtmp = @rowextract(brsp_lvl{!j},!i)
		rsp_lvl_rom_def_upp_1(!i,!j) = @quantile(rtmp,0.833)
		rsp_lvl_rom_def_low_1(!i,!j) = @quantile(rtmp,0.167)
		rsp_lvl_rom_def_med_1(!i,!j) = @quantile(rtmp,0.5)
		rtmp = @rowextract(brsp_acc{!j},!i)
		rsp_acc_rom_def_upp_1(!i,!j) = @quantile(rtmp,0.833)
		rsp_acc_rom_def_low_1(!i,!j) = @quantile(rtmp,0.167)
		rsp_acc_rom_def_med_1(!i,!j) = @quantile(rtmp,0.5)
	next
next
delete re_*
delete res_*
delete acc_*
delete brsp_*
delete gr_qgdp_0*
delete gr_qgdp_a vtmp rtmp 
delete model_*
delete eq_2
delete rsp_lvl_rom_*
delete tt_rom_def1

